/* MIDI.H
 Rumpf einer MIDI-Bibliothek
 Entwickelt mit Turbo-C 2.0
 Vorlesung MUSIKELEKTRONIK FH-Mnehen FB06
 (C) 1991 Prof. Herbert Walz
 Anton-Kck-Str. 8a
 D-8023 Pullach b. Mnchen */
#include <tos.h>
/* MIDI-Kanle */
#define k1 k = 0;
#define k2 k = 1;
#define k3 k = 2;
#define k4 k = 3;
/* Tonhhe ein */
#define d1 ton_ein (0x3e);
#define fis1 ton_ein (0x42);
#define a1 ton_ein (0x45);
#define d2 ton-ein (0x4a);
#define e2 ton_ein (0x4c);
/*Tonhhe aus */
#define d1_ ton_aus (0x3e);
#define fis1_ ton_aus (0x42);
#define a1_ ton_aus (0x45);
#define d2_ ton_aus (0x44);
#define e2_ ton_aus (0x4c);
/*Tondauer */
#define t1 tondauer (1); /* Tondauer 1/1 */
#define t2 tondauer (2); /* Tondauer 1/2 */
#define t4 tondauer (4); /* Tondauer 1/4 */
/* Dynamik absolut */
#define mf dyn = 0x48 /*mezzoforte */
/*Globale Deklarationen */
int k; /* Kanalzahl */
int th; /* Tonhhe */
int dyn; /* Dynamik */
int M; /* Metronomzahl */

/* Funktionsprototypen */
void tondauer (long td);
void ton_ein (int th);
void ton_aus (int th);
/* Tondauer */
void tondauer (long td)
{
 long i;
 /* Konstante fr genaue Metronomzahl */
 td = 77300000L / M / td;
 for (i = 0; i < td; i++);
}
/* Ton ein */
void ton_ein (int th)
{
 Bconout (3, 0x90 + k); /* Ton ein auf Kanal k */
 Bconout (3, th); /* Tonhhe th */
 Bconout (3, dyn); /* Anschlagdynamik dyn */
}
/* Ton aus */
void ton_aus (int th)
{
 Bconout (3, 0x80 + k); /* Ton aus auf Kanal k */
 Bconout (3, th); /* Tonhhe th */
 Bconout (3, dyn); /* Anschlagdynamik dyn */
}
